

#   if {![info exists ::AIDA]} {return}

#   if {![info exists ::AIDA::ModuleMenu]} {set ::AIDA::ModuleMenu [list localhost]}
#   if {![info exists ::AIDA::FEE64]} {set ::AIDA::FEE64 [first $::AIDA::ModuleMenu]}



    proc ReadAIDARegister {Addr}  {
        global errorCode errorInfo
        global MIDAS_XAIDAAccessServer_Exists
        global XAIDAAccessServerHost

# puts "Get Addr=[format \"0x%x\" $Addr]"
# return 0

        if {[info exists MIDAS_XAIDAAccessServer_Exists]} {
# puts "ReadAIDARegister do_Get"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XAIDAAccessServer do_Get $Addr} m]
        } else {
            if {$XAIDAAccessServerHost != $::AIDA::FEE64} {
                set XAIDAAccessServerHost  $::AIDA::FEE64
# puts "ReadAIDARegister configure $XAIDAAccessServerHost"
                XAIDAAccessClient_Configure
            }
# puts "ReadAIDARegister  $XAIDAAccessServerHost  XAIDAAccessClient__Get"
            set rc [catch {XAIDAAccessClient__Get $Addr} m]
        }
        if {$rc != 0} {
#            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
  puts "ReadAIDARegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#  puts "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc WriteAIDARegister {Addr Vl}  {
        global errorCode errorInfo
        global MIDAS_XAIDAAccessServer_Exists
        global XAIDAAccessServerHost

# puts "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
# return 0

        if {[info exists MIDAS_XAIDAAccessServer_Exists]} {
# puts "WriteAIDARegister do_Set"
            set rc [catch {interp eval "" ::namespace inscope ::urn:XAIDAAccessServer do_Set $Addr $Vl} m]
        } else {
            if {$XAIDAAccessServerHost != $::AIDA::FEE64} {
                set XAIDAAccessServerHost  $::AIDA::FEE64
# puts "WriteAIDARegister configure $XAIDAAccessServerHost"
                XAIDAAccessClient_Configure
            }
# puts "WriteAIDARegister XAIDAAccessClient__Set"
            set rc [catch {XAIDAAccessClient__Set $Addr $Vl} m]
        }
        if {$rc != 0} {
#            InsertLog "Set returned with an error\n$m\n$errorCode\n$errorInfo"
           puts "WriteAIDARegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
#            puts "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc ReadAD9252Register {C Addr}  {
        global errorCode errorInfo
        global MIDAS_XAD9252AccessServer_Exists
        global XAD9252AccessServerHost

# puts "Get Addr=[format \"0x%x\" $Addr]"
# return 0

        if {[info exists MIDAS_XAD9252AccessServer_Exists]} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:XAD9252AccessServer do_Get $C $Addr} m]
        } else {
            if {$XAD9252AccessServerHost != $::AIDA::FEE64} {
                set XAD9252AccessServerHost  $::AIDA::FEE64
                XAD9252AccessClient_Configure
            }
            set rc [catch {XAD9252AccessClient__Get $C $Addr} m]
        }
        if {$rc != 0} {
            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Get Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

    proc WriteAD9252Register {C Addr Vl}  {
        global errorCode errorInfo
        global MIDAS_XAD9252AccessServer_Exists
        global XAD9252AccessServerHost

# puts "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
# return 0

        if {[info exists MIDAS_XAD9252AccessServer_Exists]} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:XAD9252AccessServer do_Set $C $Addr $Vl} m]
        } else {
            if {$XAD9252AccessServerHost != $::AIDA::FEE64} {
                set XAD9252AccessServerHost  $::AIDA::FEE64
                XAD9252AccessClient_Configure
            }
            set rc [catch {XAD9252AccessClient__Set $C $Addr $Vl} m]
        }
        if {$rc != 0} {
            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
#            InsertLog "Set $Vl => Addr=[format \"0x%x\" $Addr] => $m [format \"0x%x\" $m]"
            return $m
        }
    }

